#ifndef VIDEOPLAYER_H
#define VIDEOPLAYER_H
#include <QMutex>
#include <QThread>
#include <QImage>
#include <QWaitCondition>
#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <VideoManager.hpp>

using namespace cv;
class VideoPlayer : public QThread
{
	Q_OBJECT
private:
	VideoManager* vidMgr;

	bool stop;
	QMutex mutex;
	QWaitCondition condition;
	Mat frame;
	int frameRate;
	
	Mat RGBframe;
	QImage img;
signals:
	void processedImage(const QImage &image); //signal for processed video frame
protected:
	void run();
	void msleep(int ms);
public:
	VideoPlayer(VideoManager* videoManager, QObject *parent = 0);
	~VideoPlayer();

	bool loadVideo(std::string filename); //set input in VideoManager
	void Play(); //start playback
	void Stop(); //stop playback
	bool isStopped() const; //is playback stopped?

	void setCurrentFrame(int frameNumber); //jump to specific frame

	//video properties
	double getFrameRate();
	double getCurrentFrame();
	double getNumberOfFrames();
};
#endif // VIDEOPLAYER_H